#
# Additional build rules for MacPerl extensions
#

COpt     += -i $(PERL_SRC) -w nopossible
PERL_LIB = $(PERL_SRC)lib:
PERL_INC = $(PERL_SRC)
PERL_INST= :blib:lib:
PERL     = $(PERL_SRC)miniperl
# Where is the Config.pm that we are using/depend on
CONFIGDEP= $(PERL_LIB)Config.pm
DLSRC    = dl_mac.xs

EXPORT_FILE	*= $(BASEEXT).exp
EXPORTS	 	*= -@export $(EXPORT_FILE)

FULLEXT	*=	$(NAME)
BASEEXT *= 	$(NAME)
ROOTEXT *=

# Where to put things:
INST_LIBDIR	= $(PERL_INST)$(ROOTEXT)
INST_AUTODIR= $(PERL_INST)auto:$(FULLEXT):

INST_BOOT    = $(INST_AUTODIR)$(BASEEXT).bs
INST_DYNAMIC = $(INST_AUTODIR)$(BASEEXT)

STATIC_LIB_68K = $(BASEEXT).Lib.68K
STATIC_LIB_680 = $(BASEEXT).Lib.680
STATIC_LIB_PPC = $(BASEEXT).Lib.PPC
DYNAMIC_LIB_PPC= $(BASEEXT).shlb

AUTOSPLITFILE	= $(PERL) -I$(PERL_LIB) -e 'use AutoSplit; AutoSplit::autosplit($$ARGV[0], $$ARGV[1], 0, 1, 1) ;'
LNS				= $(PERL) -e 'symlink($$ARGV[0], $$ARGV[1])'
MKPATH			= $(PERL) -e 'use File::Path; mkpath(\@ARGV, 1);'
XSUBPP			= $(PERL_LIB)ExtUtils:xsubpp
XSUBPPARGS		= $(TYPEMAPS:^"-typemap ") $(XSPROTOARG)
CP              = Duplicate -y 
RM_RF			= $(PERL_SRC)SafeDel
MV			    = Rename -y

SOURCE 		*= $(BASEEXT).c $(MORE_SRC)
MODULES		*= $(BASEEXT).pm $(MORE_MODS)

Objects68K	=  {$(SOURCE)}.68K.o
Objects680	=  {$(SOURCE)}.680.o
ObjectsPPC	=  {$(SOURCE)}.PPC.o

%.c .PRECIOUS : %.xs
	Set Echo 1
	$(PERL) -I$(PERL_LIB) $(XSUBPP) $(XSUBPPARGS) $< >xstmp.c && Rename -y xstmp.c $@
%.cp .PRECIOUS : %.xs
	Set Echo 1
	$(PERL) -I$(PERL_LIB) $(XSUBPP) $(XSUBPPARGS) $< >xstmp.cp && Rename -y xstmp.c $@

static:  $(STATIC_LIB_68K) $(STATIC_LIB_680) $(STATIC_LIB_PPC)
dynamic: $(DYNAMIC_LIB_PPC)

install_static: $(MODULES) $(XS_FILES)
	$(MKPATH) $(INST_LIBDIR) $(INST_LIBDIR){$(PMLIBDIRS)}
	For i in $(MODULES:^"@":s/@://:s/@//) $(XS_FILES:^"@":s/@://:s/@//)
		$(CP) :{{i}} $(INST_LIBDIR){{i}}
	End
install_dynamic: install_static $(DYNAMIC_LIB_PPC)
	$(MKPATH) $(INST_AUTODIR)
	Duplicate -y $(DYNAMIC_LIB_PPC) $(INST_DYNAMIC)
install_dynamic_debug: install_dynamic
	Duplicate -y $(DYNAMIC_LIB_PPC).xSYM $(INST_DYNAMIC).xSYM
	

DYNAMIC_STDLIBS_PPC	*= $(PERL_SRC)Perl {{MWPPCLibraries}}InterfaceLib {{MWPPCLibraries}}ShLibRuntime.Lib

$(STATIC_LIB_68K) : Objects68K
	$(Lib68K) -o $(STATIC_LIB_68K) :Obj:{$(Objects68K)}
$(STATIC_LIB_680) : Objects680
	$(Lib68K) -o $(STATIC_LIB_680) :Obj:{$(Objects680)}
$(STATIC_LIB_PPC) : ObjectsPPC
	$(LibPPC) -o $(STATIC_LIB_PPC) :Obj:{$(ObjectsPPC)}
$(DYNAMIC_LIB_PPC) : ObjectsPPC $(EXPORT_FILE)
	$(SharedLibPPC) $(EXPORTS) -name $(BASEEXT) -o $(DYNAMIC_LIB_PPC) :Obj:{$(ObjectsPPC)} $(DYNAMIC_STDLIBS_PPC) $(LDLOADLIBS)

clean: 
	$(RM_RF) ':Obj:'
	
realclean:
	$(RM_RF) '.Lib.' $(DYNAMIC_LIB_PPC)
