/* $Header: tyrathect:Development:Perl::RCS:missing.c,v 1.2 1994/05/04 02:12:43 neeri Exp $
 *
 *    Copyright (c) 1996 Matthias Neeracher
 *
 *    You may distribute under the terms of the Perl Artistic License,
 *    as specified in the README file.
 *
 * $Log: missing.c,v $
 */

#define MAC_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <stdarg.h>
#include <Types.h>
#include <Memory.h>
#include <AppleEvents.h>
#include "PerlAEUtils.h"
#include "SubLaunch.h"

typedef int 	SysRet;
typedef long	SysRetLong;

#define AEFail(error)	if (gLastMacOSErr = (error)) { XSRETURN_UNDEF; } else 0

MODULE = Mac::AppleEvents	PACKAGE = AEDesc

AEDesc
new(package, type='null', data=0)
	SV *		package
	OSType	type
	Handle	data
	CODE:
	{
		RETVAL.descriptorType	=	type;
		RETVAL.dataHandle			=	data;
	}
	OUTPUT:
	RETVAL

OSType
type(desc, newType=0)
	AEDesc	desc
	OSType	newType
	CODE:
	{
		if (items>1)
			desc.descriptorType	=	newType;
		RETVAL = desc.descriptorType;
	}
	OUTPUT:
	desc
	RETVAL

Handle
data(desc, newData=0)
	AEDesc	desc
	Handle	newData
	CODE:
	{
		if (items>1)
			desc.dataHandle	=	newData;
		RETVAL = desc.dataHandle;
	}
	OUTPUT:
	desc
	RETVAL

MODULE = Mac::AppleEvents	PACKAGE = AEKeyDesc

AEKeyDesc
new(package, key=0, type='null', data=0)
	SV *		package
	OSType	key
	OSType	type
	Handle	data
	CODE:
	{
		RETVAL.descKey								=	key;
		RETVAL.descContent.descriptorType	=	type;
		RETVAL.descContent.dataHandle			=	data;
	}
	OUTPUT:
	RETVAL

OSType
key(desc, newKey=0)
	AEKeyDesc	desc
	OSType		newKey
	CODE:
	{
		if (items>1)
			desc.descKey	=	newKey;
		RETVAL = desc.descKey;
	}
	OUTPUT:
	desc
	RETVAL

OSType
type(desc, newType=0)
	AEKeyDesc	desc
	OSType		newType
	CODE:
	{
		if (items>1)
			desc.descContent.descriptorType	=	newType;
		RETVAL = desc.descContent.descriptorType;
	}
	OUTPUT:
	desc
	RETVAL

Handle
data(desc, newData=0)
	AEKeyDesc	desc
	Handle		newData
	CODE:
	{
		if (items>1)
			desc.descContent.dataHandle	=	newData;
		RETVAL = desc.descContent.dataHandle;
	}
	OUTPUT:
	desc
	RETVAL

MODULE = Mac::AppleEvents	PACKAGE = Mac::AppleEvents

AEDesc
AECreateDesc(typeCode, data)
	OSType	typeCode
	SV *		data
	CODE:
	{
		void *	dataPtr;
		STRLEN	dataSize;
		
		dataPtr = SvPV(data, dataSize);
		
		AEFail(AECreateDesc(typeCode, dataPtr, dataSize, &RETVAL));
	}
	OUTPUT:
	RETVAL

AEDesc
AECoerce(typeCode, data, toType)
	OSType	typeCode
	SV *		data
	OSType	toType
	CODE:
	{
		void *	dataPtr;
		STRLEN	dataSize;
		
		dataPtr = SvPV(data, dataSize);
		AEFail(AECoercePtr(typeCode, dataPtr, dataSize, toType, &RETVAL));
	}
	OUTPUT:
	RETVAL

AEDesc
AECoerceDesc(theAEDesc, toType)
	AEDesc	&theAEDesc
	OSType	toType
	CODE:
	AEFail(AECoerceDesc(&theAEDesc, toType, &RETVAL));
	OUTPUT:
	RETVAL

MacOSRet
AEDisposeDesc(theAEDesc)
	AEDesc	&theAEDesc

AEDesc
AEDuplicateDesc(theAEDesc)
	AEDesc	&theAEDesc
	CODE:
	AEFail(AEDuplicateDesc(&theAEDesc, &RETVAL));
	OUTPUT:
	RETVAL

AEDesc
AECreateList(factoring, isRecord)
	SV *		factoring
	Boolean	isRecord
	CODE:
	{
		void *	factoringPtr;
		STRLEN	factoredSize;
		
		factoringPtr 	= 	SvPV(factoring, factoredSize);
		AEFail(AECreateList(factoringPtr, factoredSize, isRecord, &RETVAL));
	}
	OUTPUT:
	RETVAL

SysRetLong
AECountItems(theAEDescList)
	AEDesc	&theAEDescList
	CODE:
	AEFail(AECountItems(&theAEDescList, &RETVAL));
	OUTPUT:
	RETVAL

MacOSRet
AEPut(theAEDescList, index, typeCode, data)
	AEDesc	&theAEDescList
	long		index
	OSType	typeCode
	SV *		data
	CODE:
	{
		void *	dataPtr;
		STRLEN	dataSize;
		
		dataPtr 	= 	SvPV(data, dataSize);
		RETVAL	=	AEPutPtr(&theAEDescList, index, typeCode, dataPtr, dataSize);
	}
	OUTPUT:
	RETVAL

MacOSRet
AEPutDesc(theAEDescList, index, theAEDesc)
	AEDesc	&theAEDescList
	long		index
	AEDesc	&theAEDesc

void
AEGetNthDesc(theAEDescList, index, desiredType=typeWildCard)
	AEDesc	&theAEDescList
	long		index
	OSType	desiredType
	PPCODE:
	{
		OSType 	kw;
		AEDesc	desc;
		
		AEFail(AEGetNthDesc(&theAEDescList, index, desiredType, &kw, &desc));
		EXTEND(sp, 2);
		PUSHs(sv_setref_pvn(sv_newmortal(), "AEDesc", (void*)&desc, sizeof(AEDesc)));
		if (kw != typeWildCard)
			PUSHs(sv_2mortal(newSVpv((char *)&kw, 4)));
	}

MacOSRet
AEDeleteItem(theAEDescList, index)
	AEDesc	&theAEDescList
	long		index

MacOSRet
AEPutParam(theAppleEvent, theAEKeyword, typeCode, data)
	AEDesc	&theAppleEvent
	OSType	theAEKeyword
	OSType	typeCode
	SV *		data
	CODE:
	{
		void *	dataPtr;
		STRLEN	dataSize;
		
		dataPtr 	= 	SvPV(data, dataSize);
		RETVAL	=	AEPutParamPtr(&theAppleEvent, theAEKeyword, typeCode, dataPtr, dataSize);
	}
	OUTPUT:
	RETVAL

MacOSRet
AEPutParamDesc(theAppleEvent, theAEKeyword, theAEDesc)
	AEDesc	&theAppleEvent
	OSType	theAEKeyword
	AEDesc	&theAEDesc

AEDesc
AEGetParamDesc(theAppleEvent, theAEKeyword, desiredType=typeWildCard)
	AEDesc	&theAppleEvent
	OSType	theAEKeyword
	OSType	desiredType
	CODE:
	AEFail(AEGetParamDesc(&theAppleEvent, theAEKeyword, desiredType, &RETVAL));
	OUTPUT:
	RETVAL

MacOSRet
AEDeleteParam(theAppleEvent, theAEKeyword)
	AEDesc	&theAppleEvent
	OSType	theAEKeyword

AEDesc
AEGetAttributeDesc(theAppleEvent, theAEKeyword, desiredType=typeWildCard)
	AEDesc	&theAppleEvent
	OSType	theAEKeyword
	OSType	desiredType
	CODE:
	AEFail(AEGetAttributeDesc(&theAppleEvent, theAEKeyword, desiredType, &RETVAL));
	OUTPUT:
	RETVAL

MacOSRet
AEPutAttribute(theAppleEvent, theAEKeyword, typeCode, data)
	AEDesc	&theAppleEvent
	OSType	theAEKeyword
	OSType	typeCode
	SV *		data
	CODE:
	{
		void *	dataPtr;
		STRLEN	dataSize;
		
		dataPtr 	= 	SvPV(data, dataSize);
		RETVAL	=	AEPutAttributePtr(&theAppleEvent, theAEKeyword, typeCode, dataPtr, dataSize);
	}
	OUTPUT:
	RETVAL

MacOSRet
AEPutAttributeDesc(theAppleEvent, theAEKeyword, theAEDesc)
	AEDesc	&theAppleEvent
	OSType	theAEKeyword
	AEDesc	&theAEDesc

AEDesc
AECreateAppleEvent(theAEEventClass, theAEEventID, target, returnID=kAutoGenerateReturnID, transactionID=0)
	OSType	theAEEventClass
	OSType	theAEEventID
	AEDesc	&target
	short		returnID
	long		transactionID
	CODE:
	if (gPAECreate)
		AEFail(
			CallOSACreateAppleEventProc(gPAECreate,
				theAEEventClass, theAEEventID, 
				&target, returnID, transactionID, &RETVAL, 
				gPAECreateRefCon));
	else
		AEFail(
			AECreateAppleEvent(
				theAEEventClass, theAEEventID, 
				&target, returnID, transactionID, &RETVAL));
	OUTPUT:
	RETVAL

AEDesc
AESend(theAppleEvent, sendMode, sendPriority=kAENormalPriority, timeout=kAEDefaultTimeout)
	AEDesc	&theAppleEvent
	long		sendMode
	short		sendPriority
	long		timeout
	CODE:
	if (gPAESend) 
		AEFail(
			CallOSASendProc(gPAESend,
				&theAppleEvent, &RETVAL, 
				sendMode, sendPriority, timeout, (AEIdleUPP) &uSubLaunchIdle, nil,
				gPAESendRefCon));
	else
		AEFail(
			AESend(
				&theAppleEvent, &RETVAL, 
				sendMode, sendPriority, timeout, (AEIdleUPP) &uSubLaunchIdle, nil));
	OUTPUT:
	RETVAL

MacOSRet
AEResetTimer(reply)
	AEDesc	&reply

MacOSRet
AESuspendTheCurrentEvent(theAppleEvent)
	AEDesc	&theAppleEvent

MacOSRet
AEResumeTheCurrentEvent(theAppleEvent, reply, handlerRefcon=0)
	AEDesc	&theAppleEvent
	AEDesc	&reply	= NO_INIT
	long		handlerRefcon
	CODE:
	{
		if (items > 2)
			RETVAL = 
				AEResumeTheCurrentEvent(
					&theAppleEvent, &reply, (AEEventHandlerUPP) kAEUseStandardDispatch, 
					handlerRefcon);
		else
			RETVAL = 
				AEResumeTheCurrentEvent(
					&theAppleEvent, &reply, (AEEventHandlerUPP) kAENoDispatch, 
					handlerRefcon);
	}
	OUTPUT:
	RETVAL

MacOSRet
AEGetTheCurrentEvent(theAppleEvent)
	AEDesc	&theAppleEvent

MacOSRet
AESetTheCurrentEvent(theAppleEvent)
	AEDesc	&theAppleEvent

SysRet
AEGetInteractionAllowed()
	CODE:
	{
		char	level;
		
		AEFail(AEGetInteractionAllowed((AEInteractAllowed *)&level));
		RETVAL = level;
	}

MacOSRet
AESetInteractionAllowed(level)
	char	level
	CODE:
	RETVAL = AESetInteractionAllowed((AEInteractAllowed)level);
	OUTPUT:
	RETVAL

MacOSRet
AEInstallEventHandler(theAEEventClass, theAEEventID, handler, handlerRefcon, isSysHandler=0)
	OSType	theAEEventClass
	OSType	theAEEventID
	SV *		handler
	SV *		handlerRefcon
	Boolean	isSysHandler
	CODE:
	{
		RETVAL = PAEInstallEventHandler(theAEEventClass, theAEEventID, handler, handlerRefcon, isSysHandler);
	}
	OUTPUT:
	RETVAL

MacOSRet
AERemoveEventHandler(theAEEventClass, theAEEventID, isSysHandler=0)
	OSType	theAEEventClass
	OSType	theAEEventID
	Boolean	isSysHandler
	CODE:
	RETVAL = PAERemoveEventHandler(theAEEventClass, theAEEventID, isSysHandler);
	OUTPUT:
	RETVAL

void
AEGetEventHandler(theAEEventClass, theAEEventID, isSysHandler=0)
	OSType	theAEEventClass
	OSType	theAEEventID
	Boolean	isSysHandler
	PPCODE:
	{
		SV * handler = sv_newmortal();
		SV * refCon  = sv_newmortal();
		
		AEFail(
			PAEGetEventHandler(
				theAEEventClass, theAEEventID, handler, refCon, isSysHandler));
		EXTEND(sp, 2);
		PUSHs(handler);
		PUSHs(refCon);
	}

SysRetLong
AEManagerInfo(keyWord)
	OSType	keyWord
	CODE:
	AEFail(AEManagerInfo(keyWord, &RETVAL));
	OUTPUT:
	RETVAL

AEDesc
AEBuild(format, ...)
	char *	format
	CODE:
	{
		int	item = 1;
		char *formscan = format;
		
		PAEClearArgs();
		for (;item<items;++item) 
			if (!PAEDoNextParam(&formscan, ST(item)))
				croak("Too many arguments to AEBuild()");
			
		if (PAENextParam(&formscan))
			croak("Not enough arguments to AEBuild()");
		AEFail(vAEBuild(&RETVAL, format, gPAEArgs));
	}
	OUTPUT:
	RETVAL

MacOSRet
AEBuildParameters(event, format, ...)
	AEDesc	&event
	char *	format
	CODE:
	{
		int	item = 2;
		char *formscan = format;
		
		PAEClearArgs();
		for (;item<items;++item) 
			if (!PAEDoNextParam(&formscan, ST(item)))
				croak("Too many arguments to AEBuildParameters()");
			
		if (PAENextParam(&formscan))
			croak("Not enough arguments to AEBuildParameters()");
		RETVAL = vAEBuildParameters(&event, format, gPAEArgs);
	}
	OUTPUT:
	RETVAL

AEDesc
AEBuildAppleEvent(theClass, theID, addressType, address, returnID, transactionID, paramsFmt, ... )
	OSType	theClass
	OSType	theID
	OSType	addressType
	SV *		address
	short		returnID
	long		transactionID
	char *	paramsFmt
	CODE:
	{
		int		item = 7;
		char *	formscan = paramsFmt;
		char *	addressPtr;
		STRLEN	addressLen;
		AEDesc	targetDesc;
		
		PAEClearArgs();
		addressPtr = SvPV(address, addressLen);
		for (;item<items;++item) 
			if (!PAEDoNextParam(&formscan, ST(item)))
				croak("Too many arguments to AEBuildAppleEvent()");
			
		if (PAENextParam(&formscan))
			croak("Not enough arguments to AEBuildAppleEvent()");
		AEFail(AECreateDesc(addressType, addressPtr, addressLen, &targetDesc));
		if (gPAECreate)
			AEFail(
				CallOSACreateAppleEventProc(gPAECreate,
					theClass, theID, 
					&targetDesc, returnID, transactionID, &RETVAL, 
					gPAECreateRefCon));
		else
			AEFail(
				AECreateAppleEvent(
					theClass, theID, 
					&targetDesc, returnID, transactionID, &RETVAL));
		AEDisposeDesc(&targetDesc);
		AEFail(vAEBuildParameters(&RETVAL, paramsFmt, gPAEArgs));
	}
	OUTPUT:
	RETVAL

SV *
AEPrint(desc)
	AEDesc	&desc
	CODE:
	{
		long	length;
		
		AEFail(AEPrintSize(&desc, &length));
		RETVAL = newSVpv("", length);
		AEPrint(&desc, SvPVX(RETVAL), length);
		SvCUR(RETVAL) = length-1;
	}
	OUTPUT:
	RETVAL

AESubDesc
AEDescToSubDesc(desc)
	AEDesc	&desc
	CODE:
	AEDescToSubDesc(&desc, &RETVAL);
	OUTPUT:
	RETVAL

OSType
AEGetSubDescType(subdesc)
	AESubDesc	&subdesc

OSType
AEGetSubDescBasicType(subdesc)
	AESubDesc	&subdesc

Boolean
AESubDescIsListOrRecord(subdesc)
	AESubDesc	&subdesc

SV *
AEGetSubDescData(subdesc)
	AESubDesc	&subdesc
	CODE:
	{
		void *data;
		long	length;
		
		data		= AEGetSubDescData(&subdesc, &length);
		RETVAL	= newSVpv(data, length);
	}
	OUTPUT:
	RETVAL

AEDesc
AESubDescToDesc(subdesc, desiredType=typeWildCard)
	AESubDesc	&subdesc
	OSType		desiredType
	CODE:
	AEFail(AESubDescToDesc(&subdesc, desiredType, &RETVAL));
	OUTPUT:
	RETVAL

long
AECountSubDescItems(subdesc)
	AESubDesc	&subdesc
	CODE:
	{
		RETVAL = AECountSubDescItems(&subdesc);
		if (RETVAL < 0)
			AEFail((OSErr) RETVAL);
	}
	OUTPUT:
	RETVAL	

void
AEGetNthSubDesc(subdesc,index)
	AESubDesc	&subdesc
	long			index
	PPCODE:
	{
		OSType		kw;
		AESubDesc	sub;
		
		AEFail(AEGetNthSubDesc(&subdesc, index, &kw, &sub));
		XPUSHs(sv_setref_pvn(sv_newmortal(), "AESubDesc", (void*)&sub, sizeof(AESubDesc)));
		if (GIMME == G_ARRAY && kw != typeWildCard)
			PUSHs(sv_2mortal(newSVpv((char *)&kw, 4)));
	}

AESubDesc
AEGetKeySubDesc(subdesc,kw)
	AESubDesc	&subdesc
	OSType		kw
	CODE:
	AEFail(AEGetKeySubDesc(&subdesc, kw, &RETVAL));
	OUTPUT:
	RETVAL

MODULE = Mac::AppleEvents	PACKAGE = AEStream 

AEStream
Open()
	CODE:
	AEFail(AEStream_Open(&RETVAL));
	OUTPUT:
	RETVAL

AEStream
CreateEvent(theClass, theID, addressType, address, returnID=kAutoGenerateReturnID, transactionID=0)
	OSType	theClass
	OSType	theID
	OSType	addressType
	SV *		address
	short		returnID
	long		transactionID
	CODE:
	{
		char *		addressPtr;
		STRLEN		addressLen;
		AEDesc		targetDesc;
		AppleEvent	event;
		
		addressPtr = SvPV(address, addressLen);
		AEFail(AECreateDesc(addressType, addressPtr, addressLen, &targetDesc));
		if (gPAECreate)
			AEFail(
				CallOSACreateAppleEventProc(gPAECreate,
					theClass, theID, 
					&targetDesc, returnID, transactionID, &event, 
					gPAECreateRefCon));
		else
			AEFail(
				AECreateAppleEvent(
					theClass, theID, 
					&targetDesc, returnID, transactionID, &event));
		AEDisposeDesc(&targetDesc);
		AEFail(AEStream_OpenEvent(&RETVAL, &event));
	}
	OUTPUT:
	RETVAL

AEStream
OpenEvent(theEvent)
	AEDesc	&theEvent
	CODE:
	AEFail(AEStream_OpenEvent(&RETVAL, &theEvent));
	OUTPUT:
	RETVAL

AEDesc
Close(stream)
	AEStream		&stream
	CODE:
	AEFail(AEStream_Close(&stream, &RETVAL));
	OUTPUT:
	stream
	RETVAL

MacOSRet
Abort(stream)
	AEStream		&stream
	CODE:
	RETVAL = AEStream_Close(&stream, nil);
	OUTPUT:
	stream
	RETVAL

MacOSRet
OpenDesc(stream, type)
	AEStream	&stream
	OSType	type
	CODE:
	RETVAL = AEStream_OpenDesc(&stream, type);
	OUTPUT:
	stream

MacOSRet
WriteData(stream, data)
	AEStream	&stream
	SV *		data
	CODE:
	{
		void *	ptr;
		STRLEN	length;
		
		ptr = SvPV(data, length);
		RETVAL = AEStream_WriteData(&stream, ptr, length);
	}
	OUTPUT:
	stream
	RETVAL

MacOSRet
CloseDesc(stream)
	AEStream	&stream
	CODE:
	RETVAL = AEStream_CloseDesc(&stream);
	OUTPUT:
	stream

MacOSRet
WriteDesc(stream, type, data)
	AEStream	&stream
	OSType	type
	SV *		data
	CODE:
	{
		void *	ptr;
		STRLEN	length;
		
		ptr = SvPV(data, length);
		RETVAL = AEStream_WriteDesc(&stream, type, ptr, length);
	}
	OUTPUT:
	stream
	RETVAL

MacOSRet
WriteAEDesc(stream, desc)
	AEStream	&stream
	AEDesc	&desc
	CODE:
	RETVAL = AEStream_WriteAEDesc(&stream, &desc);
	OUTPUT:
	stream

MacOSRet
OpenList(stream)
	AEStream	&stream
	CODE:
	RETVAL = AEStream_OpenList(&stream);
	OUTPUT:
	stream

MacOSRet
CloseList(stream)
	AEStream	&stream
	CODE:
	RETVAL = AEStream_CloseList(&stream);
	OUTPUT:
	stream

MacOSRet
OpenRecord(stream, type)
	AEStream	&stream
	OSType	type
	CODE:
	RETVAL = AEStream_OpenRecord(&stream, type);
	OUTPUT:
	stream

MacOSRet
SetRecordType(stream, type)
	AEStream	&stream
	OSType	type
	CODE:
	RETVAL = AEStream_SetRecordType(&stream, type);
	OUTPUT:
	stream

MacOSRet
CloseRecord(stream)
	AEStream	&stream
	CODE:
	RETVAL = AEStream_CloseRecord(&stream);
	OUTPUT:
	stream

MacOSRet
WriteKeyDesc(stream, key, type, data)
	AEStream	&stream
	OSType	key
	OSType	type
	SV *		data
	CODE:
	{
		void *	ptr;
		STRLEN	length;
		
		ptr = SvPV(data, length);
		RETVAL = AEStream_WriteKeyDesc(&stream, key, type, ptr, length);
	}
	OUTPUT:
	stream
	RETVAL

MacOSRet
OpenKeyDesc(stream, key, type)
	AEStream	&stream
	OSType	key
	OSType	type
	CODE:
	RETVAL = AEStream_OpenKeyDesc(&stream, key, type);
	OUTPUT:
	stream

MacOSRet
WriteKey(stream, key)
	AEStream	&stream
	OSType	key
	CODE:
	RETVAL = AEStream_WriteKey(&stream, key);
	OUTPUT:
	stream

MacOSRet
OptionalParam(stream, key)
	AEStream	&stream
	OSType	key
	CODE:
	RETVAL = AEStream_OptionalParam(&stream, key);
	OUTPUT:
	stream
