package Mac::Speech;

=head1 NAME

Mac::Speech - Provide interface to PlainTalk (Speech Manager)

=head1 SYNOPSIS

	use Mac::Speech;

=head1 DESCRIPTION

=include Speech.xs

=head1 BUGS/LIMITATIONS

=head1 FILES

F<Speech.pm> - Perl Interface

F<Speech.xs> - Toolbox functions

=head1 AUTHOR(S)

Matthias Ulrich Neeracher <neeri@iis.ee.ethz.ch> Author

=cut

require Exporter;
require DynaLoader;
@ISA = (Exporter, DynaLoader);
@EXPORT = qw(
	SpeechManagerVersion
	CountVoices
	GetIndVoice
	GetVoiceDescription
	NewSpeechChannel
	DisposeSpeechChannel
	SpeakString
	SpeakText
	SpeakBuffer
	StopSpeech
	StopSpeechAt
	PauseSpeechAt
	ContinueSpeech
	SpeechBusy
	SpeechBusySystemWide
	SetSpeechRate
	GetSpeechRate
	GetSpeechPitch
 SetSpeechPitch
	kTextToSpeechSynthType
	kTextToSpeechVoiceType
	kTextToSpeechVoiceFileType
	kTextToSpeechVoiceBundleType
	kNoEndingProsody
	kNoSpeechInterrupt
	kPreflightThenPause
	kImmediate
	kEndOfWord
	kEndOfSentence
	kNeuter
	kMale
	kFemale
);

bootstrap Mac::Speech;

sub kTextToSpeechSynthType ()      {     'ttsc'; }
sub kTextToSpeechVoiceType ()      {     'ttvd'; }
sub kTextToSpeechVoiceFileType ()  {     'ttvf'; }
sub kTextToSpeechVoiceBundleType () {     'ttvb'; }
sub kNoEndingProsody ()            {          1; }
sub kNoSpeechInterrupt ()          {          2; }
sub kPreflightThenPause ()         {          4; }
sub kImmediate ()                  {          0; }
sub kEndOfWord ()                  {          1; }
sub kEndOfSentence ()              {          2; }
sub kNeuter ()                     {          0; }
sub kMale ()                       {          1; }
sub kFemale ()                     {          2; }

1;

__END__
