/* $Header: tyrathect:Development:Perl::RCS:missing.c,v 1.2 1994/05/04 02:12:43 neeri Exp $
 *
 *    Copyright (c) 1996 Matthias Neeracher
 *
 *    You may distribute under the terms of the Perl Artistic License,
 *    as specified in the README file.
 *
 * $Log: missing.c,v $
 */

#define MAC_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <Types.h>
#include <Memory.h>
#include <Speech.h>
#include <FixMath.h>

#define SpeechFail(error)	if (gLastMacOSErr = (error)) { XSRETURN_UNDEF; } else 0

MODULE = Mac::Speech	PACKAGE = Mac::Speech

NumVersion 
SpeechManagerVersion()

short
CountVoices()
	CODE:
	SpeechFail(CountVoices(&RETVAL));
	OUTPUT:
	RETVAL

VoiceSpec
GetIndVoice(index)
	short index
	CODE:
	SpeechFail(GetIndVoice(index, &RETVAL));
	OUTPUT:
	RETVAL
	
VoiceDescription
GetVoiceDescription(voice)
	VoiceSpec &voice
	CODE:
	SpeechFail(GetVoiceDescription(&voice, &RETVAL, sizeof(RETVAL)));
	OUTPUT:
	RETVAL

SpeechChannel
NewSpeechChannel(voice)
	VoiceSpec &voice
	CODE:
	SpeechFail(NewSpeechChannel(&voice, &RETVAL));
	OUTPUT:
	RETVAL

MacOSRet
DisposeSpeechChannel(chan)
	SpeechChannel chan

MacOSRet
SpeakString(s)
	Str255 s;

MacOSRet
SpeakText(chan, text)
	SpeechChannel 	chan
	SV *			text
	CODE:
	{
		void *	textPtr;
		STRLEN	textSize;
		
		textPtr = 	SvPV(text, textSize);
		RETVAL	= 	SpeakText(chan, textPtr, textSize);
	}
	OUTPUT:
	RETVAL

MacOSRet
SpeakBuffer(chan, text, controlFlags)
	SpeechChannel 	chan
	SV *			text
	long			controlFlags
	CODE:
	{
		void *	textPtr;
		STRLEN	textSize;
		
		textPtr = 	SvPV(text, textSize);
		RETVAL	= 	SpeakBuffer(chan, textPtr, textSize, controlFlags);
	}
	OUTPUT:
	RETVAL

MacOSRet
StopSpeech(chan)
	SpeechChannel chan

MacOSRet
StopSpeechAt(chan, whereToStop)
	SpeechChannel 	chan
	long		  	whereToStop

MacOSRet
PauseSpeechAt(chan, whereToPause)
	SpeechChannel 	chan
	long		  	whereToPause

MacOSRet
ContinueSpeech(chan)
	SpeechChannel chan

int
SpeechBusy()

int
SpeechBusySystemWide()

MacOSRet
SetSpeechRate(chan, rate)
	SpeechChannel 	chan
	Fixed 			rate

Fixed
GetSpeechRate(chan)
	SpeechChannel	chan
	CODE:
	SpeechFail(GetSpeechRate(chan, &RETVAL));
	OUTPUT:
	RETVAL

MacOSRet
SetSpeechPitch(chan, pitch)
	SpeechChannel 	chan
	Fixed 			pitch

Fixed
GetSpeechPitch(chan)
	SpeechChannel	chan
	CODE:
	SpeechFail(GetSpeechPitch(chan, &RETVAL));
	OUTPUT:
	RETVAL
