#
# Build rules for dmake
#

#
# Tools
#

COpt		=	-sym on -d DEBUGGING -d MULTIPLICITY -w nounusedarg
C68K		=	MWC68K $(COpt) -mc68020 -model far -opt all
C680		=	MWC68K $(COpt) -model far -opt all
CPPC		=	MWCPPC $(COpt) -traceback -opt all
ROptions 	= 	-i :
Lib68K		=	MWLink68K -xm library -sym on
LibPPC		=	MWLinkPPC -xm library -sym on
SharedLibPPC=	MWLinkPPC -xm sharedlibrary -sym on
LOpt		= 	-sym on -w 
ToolLOpt	= 	$(LOpt) -xm mpwtool
ToolLink68K	=	MWLink68K $(ToolLOpt) -model far
ToolLinkPPC	=	MWLinkPPC $(ToolLOpt) 
ApplLOpt	= 	$(LOpt) -xm application
ApplLink68K	=	MWLink68K $(ApplLOpt) -model far
ApplLinkPPC	=	MWLinkPPC $(ApplLOpt) 
RsrcLink68K	=	MWLink68K $(LOpt) -xm coderesource -model far

#
# Directories
#

.INIT		:	Obj

.SOURCE.o	:	":Obj:"
.SOURCE.68K	:	":Obj:"
.SOURCE.680	:	":Obj:"
.SOURCE.PPC	:	":Obj:"
.SOURCE.c	:	":"
.SOURCE.cp	:	":"

#
# Pattern rules
#
# To maximally exploit the speed of the Metrowerks compilers, we employ a
# trick: The majority of object files has the form .c.{ARCH}.o and is subject
# to bulk compilation, while a few have the form .c.o.{ARCH} and are compiled
# one by one.
#

%.c.68K.o		:	%.c
	Set Echo 0
	Set Src68K "{{Src68K}} $<"
%.c.680.o		:	%.c
	Set Echo 0
	Set Src680 "{{Src680}} $<"
%.c.PPC.o		:	%.c
	Set Echo 0
	Set SrcPPC "{{SrcPPC}} $<"
%.cp.68K.o		:	%.cp
	Set Echo 0
	Set Src68K "{{Src68K}} $<"
%.cp.680.o		:	%.cp
	Set Echo 0
	Set Src680 "{{Src680}} $<"
%.cp.PPC.o		:	%.cp
	Set Echo 0
	Set SrcPPC "{{SrcPPC}} $<"
%.c.o.68K		:	%.c
	$(C68K) -t -ext .o.68K $< -o :Obj:
%.c.o.680		:	%.c
	$(C680) -t -ext .o.680 $< -o :Obj:
%.c.o.PPC		:	%.c
	$(CPPC) -t -ext .o.PPC $< -o :Obj:
%.cp.o.68K		:	%.cp
	$(C68K) -t -ext .o.68K $< -o :Obj:
%.cp.o.680		:	%.cp
	$(C680) -t -ext .o.680 $< -o :Obj:
%.cp.o.PPC		:	%.cp
	$(CPPC) -t -ext .o.PPC $< -o :Obj:
